LeetCode 1345. Jump Game IV

Question

Given an array of integers arr, you are initially positioned at the first index of the array.

In one step you can jump from index i to index:

  • i + 1 where: i + 1 < arr.length.
  • i - 1 where: i - 1 >= 0.
  • j where: arr[i] == arr[j] and i != j.

Return the minimum number of steps to reach the last index of the array.

Notice that you can not jump outside of the array at any time.

Example 1:

1
2
3
Input: arr = [100,-23,-23,404,100,23,23,23,3,404]
Output: 3
Explanation: You need three jumps from index 0 --> 4 --> 3 --> 9. Note that index 9 is the last index of the array.

Example 2:

1
2
3
Input: arr = [7]
Output: 0
Explanation: Start index is the last index. You do not need to jump.

Example 3:

1
2
3
Input: arr = [7,6,9,6,9,6,9,7]
Output: 1
Explanation: You can jump directly from index 0 to index 7 which is last index of the array.

Constraints:

  • 1 <= arr.length <= 5 * 104
  • -108 <= arr[i] <= 108

Source: https://leetcode.com/problems/jump-game-iv/

Solution

The idea of using queue size is to achieve layer-order traversal, like LeetCode 102. Binary Tree Level Order Traversal. So we can record the length of current search paths easily.

Repeated visits to nodes with the same value are not helpful in getting the min number of steps to the end. Thus, we can prune the BFS tree. Note that marking those nodes as visited is not enough. We need to clear corresponding key-value pair in the valueIndexMap. Because as long as these nodes are pushed to the queue, they will increase time cost.

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
public int minJumps(int[] arr) {
int len = arr.length;
// value -> list of indexes that have the same value arr[i]
Map<Integer, List<Integer>> valueIndexMap = new HashMap<>();
for (int i = 0; i < len; i++) {
if (valueIndexMap.containsKey(arr[i])) {
List<Integer> list = valueIndexMap.get(arr[i]);
list.add(i);
} else {
List<Integer> list = new ArrayList<>();
list.add(i);
valueIndexMap.put(arr[i], list);
}
}

int pathLen = 0;
boolean[] visited = new boolean[len]; // initialized with false
Queue<Integer> queue = new LinkedList<>(); // stored indexes
queue.add(0);
while (!queue.isEmpty()) {
int size = queue.size();
// traverse in layer order
for (int i = 0; i < size; i++) {
int currIndex = queue.poll();
if (visited[currIndex]) {
continue;
}
if (currIndex == len - 1) {
// the first return path is the shortest path
return pathLen;
}
visited[currIndex] = true;
if (currIndex - 1 >= 0) {
queue.add(currIndex - 1);
}
if (currIndex + 1 < len) {
queue.add(currIndex + 1);
}
for (int index : valueIndexMap.get(arr[currIndex])) {
if (index != currIndex) {
queue.add(index);
}
}
// there is no meaning to teleport to the same value on current and further iterations
// only produce paths with identical or larger length
// so that to waive repeated inner loop
valueIndexMap.get(arr[currIndex]).clear();
}
pathLen++;
}
return -1;
}
Author

Weihao Ye

Posted on

2022-01-25

Updated on

2022-01-25

Licensed under